"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const broccoli_caching_writer_1 = __importDefault(require("broccoli-caching-writer"));
const path_1 = __importDefault(require("path"));
const mkdirp_1 = __importDefault(require("mkdirp"));
const fs_1 = __importDefault(require("fs"));
const sass_1 = __importDefault(require("sass"));
class SassCompiler extends broccoli_caching_writer_1.default {
    constructor(inputTrees, inputFile, outputFile, options) {
        super(inputTrees, Object.assign(Object.assign({}, options), { persistentOutput: true }));
        this.inputFile = inputFile;
        this.outputFile = outputFile;
        this.options = options;
        this.previous = [];
    }
    async build() {
        var destFile = path_1.default.join(this.outputPath, this.outputFile);
        var sassOptions = {
            file: path_1.default.join(this.inputPaths[0], this.inputFile),
            includePaths: this.inputPaths,
            outputStyle: this.options.outputStyle,
            precision: this.options.precision,
            sourceComments: this.options.sourceComments,
        };
        const result = sass_1.default.renderSync(sassOptions);
        try {
            fs_1.default.writeFileSync(destFile, result.css);
        }
        catch (error) {
            mkdirp_1.default.sync(path_1.default.dirname(destFile));
            fs_1.default.writeFileSync(destFile, result.css);
        }
    }
}
exports.default = SassCompiler;
